PROGRAM Compile_CRACK;
USES GUtils;

CONST
  PatternSize = 25;
  MaxCrack    = 20;

TYPE
  TByteData = RECORD
      Search : STRING[PatternSize];
     Replace : STRING[PatternSize];
  END;
  TCrackData = RECORD
        Logo : ARRAY[1..4000] OF Byte;
      YCoord : Byte;
  CrackTotal : Byte;
    FileName : STRING[12];
        Data : ARRAY[1..MaxCrack] OF TByteData;
  END;


CONST
  ID: ARRAY[1..4] OF Char = 'DATA';


VAR
  ID_Bytes        : ARRAY[1..4] OF Char;
  Offset          : LongInt;
  CrackData       : TCrackData;
  ScriptFileName  : STRING;
  CompileFileName : STRING;


  PROCEDURE Error(Msg:STRING);
  BEGIN
    WriteLn(MSG);
    Halt(1)
  END;



{---------------------------------------------------------------------------}
{---------------------------------------------------------------------------}
{---------------------------------------------------------------------------}
PROCEDURE InitFindReplace(VAR NEW_Find,NEW_Replace:STRING);
VAR I,R: Byte; S1,S2: STRING[2];
BEGIN
  NEW_Find    := StripAll(NEW_Find   ,' ');
  NEW_Replace := StripAll(NEW_Replace,' ');
  IF Odd(Length(NEW_Find))    THEN NEW_Find[0]    := Chr(Ord(NEW_Find[0])-1);
  IF Odd(Length(NEW_Replace)) THEN NEW_Replace[0] := Chr(Ord(NEW_Replace[0])-1);
  R := 0;
  FOR I := 1 TO Length(NEW_Find) DO
  BEGIN
    S1 := Copy(NEW_Find   ,I,2);
    S2 := Copy(NEW_Replace,I,2);
    Inc(I); Inc(R);
    NEW_Find   [R] := Chr(HexToDec(S1));
    NEW_Replace[R] := Chr(HexToDec(S2));
  END;
  NEW_Find[0]    := Chr(Ord(NEW_Find[0])    DIV 2);
  NEW_Replace[0] := Chr(Ord(NEW_Replace[0]) DIV 2);
END;


{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE GenerateCrackData;
VAR ScriptFile:Text; LogoFile:FILE; Crk:FILE; Line,Fnd,Rep:STRING[80];
BEGIN
  FillChar(CrackData, SizeOf(CrackData), 0);
  Writeln('Compiling script file ',ScriptFileName,' to ',CompileFileName);
  Writeln;
  Assign(ScriptFile,ScriptFileName);
  {$I-}
    Reset(ScriptFile);
  {$I+}
  IF IOResult <> 0 THEN Error('Error openning '+ScriptFileName);
  ReadLn(ScriptFile,Line);
  Writeln('Script name    : ',Line);
  ReadLn(ScriptFile,Line);
           Assign(LogoFile,Line);
           {$I-} Reset(LogoFile,1); {$I+}
           IF IOResult <> 0 THEN Error('SCRIPT FILE ERROR: Error openning '+Line);
           BlockRead(LogoFile,CrackData.Logo,SizeOf(CrackData.Logo));
           Close(LogoFile);
  Writeln('Logo file      : ',Line);
  ReadLn(ScriptFile,Line); CrackData.YCoord := StrToInt(Line);
  Writeln('Cursor YPos    : ',CrackData.YCoord);
  ReadLn(ScriptFile,Line); CrackData.FileName := Line;
  Writeln('Search in file : ',CrackData.FileName);
  REPEAT
    Inc(CrackData.CrackTotal);
    ReadLn(ScriptFile,Fnd);
    ReadLn(ScriptFile,Rep);
    ReadLn(ScriptFile,Line); {!!!!!!!!!!!!}
    InitFindReplace(Fnd,Rep);
    CrackData.Data[CrackData.CrackTotal].Search  := Fnd;
    CrackData.Data[CrackData.CrackTotal].Replace := Rep;
    IF CrackData.CrackTotal = MaxCrack THEN Break;
  UNTIL Eof(ScriptFile);
  Close(ScriptFile);
  Writeln('Search patterns: ',CrackData.CrackTotal);
END;



PROCEDURE SaveCrackData;
VAR Crk:FILE;
BEGIN
  CopyFile('EC2_OVL.OVL',CompileFileName);
  Assign(Crk,CompileFileName);
  {$I-}
    Reset(Crk,1);
  {$I-}
  IF IOresult <> 0 THEN Error('Can''t open '+CompileFileName);
  Seek(Crk,Offset);
  BlockRead(Crk,ID_Bytes,SizeOf(ID_Bytes));
  IF ID_Bytes <> ID THEN
  BEGIN
    Close(Crk);
    DeleteFile('EC2_OVL.OVL');
    Error('Can''t locate DATA marker. Check whether EC2_OVL.OVL is compressed!');
  END;
  BlockWrite(Crk,CrackData,SizeOf(CrackData));
  Close(Crk);
END;


{***************************************************************************}
{****************************** MAIN PROGRAM *******************************}
{***************************************************************************}
BEGIN
  Offset := (8*512)+98;

  Writeln('EASY CRACK v2.0');
  Writeln('Copyright (C) 1997 by The GodFather');
  Writeln;
  IF NOT Exist('EC2_OVL.OVL')
    THEN Error('ERROR: EC2_OVL.OVL must be in current directory!');

  IF ParamCount < 1
    THEN Error('Usage: EC2 script_file_name [crack_file_name]');

  ScriptFileName  := AdjCase(Upper, ParamStr(1));
  IF ParamCount >= 2
    THEN CompileFileName := AdjCase(Upper, BaseNameOnly(ParamStr(2))+'.EXE')
    ELSE CompileFileName := AdjCase(Upper, BaseNameOnly(ScriptFileName)+'.EXE');

  GenerateCrackData;
  SaveCrackData;

  Writeln;
  Writeln(CompileFileName,' is created.');
END.